#if OPENGL
#define SV_POSITION POSITION
#define VS_SHADERMODEL vs_3_0
#define PS_SHADERMODEL ps_3_0
#else
#define VS_SHADERMODEL vs_4_0_level_9_1
#define PS_SHADERMODEL ps_4_0_level_9_1
#endif
float2 TexelSize; // should be (1f/textureSize.X, 1f/textureSize.Y)
int BorderSize;
float R;
float G;
float B;
float2 ImageSize;

sampler2D SpriteTextureSampler = sampler_state
{
  Texture = <SpriteTexture>;
};

struct VertexShaderOutput
{
  float4 Color : COLOR0;
  float2 TextureCoordinates : TEXCOORD0;
};

float4 MainPS(VertexShaderOutput input) : COLOR
{
    // float4 color = tex2Dlod(SpriteTextureSampler, float4   (input.TextureCoordinates.x, input.TextureCoordinates.y, 0,0));
    
    // if (color.a > 0)
    // {
    //     return color;
    // }

    // float2 pixelSize.x = float2(pixelSize.x, 0);
    // float2 pixelSize.y =  float2( 0, pixelSize.y );

    // for (int i = 1; i < 10; i++)
    // {
    //     if (i<=BorderSize)
    //     {
    //         float4 c1 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates + pixelSize.x*i).x, (input.TextureCoordinates + pixelSize.x*i).y,0,0));
    //         float4 c2 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates - pixelSize.x*i).x,(input.TextureCoordinates - pixelSize.x*i           ).y          ,0,0));
    //         float4 c3 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates + pixelSize.y*i           ).x,(input.TextureCoordinates + pixelSize.y*i           ).y          ,0,0));
    //         float4 c4 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates - pixelSize.y*i           ).x,(input.TextureCoordinates - pixelSize.y*i           ).y          ,0,0));
    //         float4 d1 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates - (pixelSize.x+pixelSize.y)*i ).x,(input.TextureCoordinates - (pixelSize.x+pixelSize.y)*i ).y          ,0,0));
    //         float4 d2 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates + (pixelSize.x+pixelSize.y)*i).x,(input.TextureCoordinates + (pixelSize.x+pixelSize.y)*i).y           ,0,0));
    //         float4 d3 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates - (pixelSize.x-pixelSize.y)*i ).x,(input.TextureCoordinates - (pixelSize.x-pixelSize.y)*i ).y          ,0,0));
    //         float4 d4 = tex2Dlod(SpriteTextureSampler, float4((input.TextureCoordinates - (-pixelSize.x+pixelSize.y)*i).x,(input.TextureCoordinates - (-pixelSize.x+pixelSize.y)*i).y          ,0,0));
            
    //         if (color.a != c1.a || color.a != c2.a|| color.a != c3.a|| color.a != c4.a
    //         || color.a != d1.a 
    //         || color.a != d2.a
    //         || color.a != d3.a
    //         || color.a != d4.a
    //         )
    //         {
    //             color.r=R;
    //             color.g=G;
    //             color.b=B;
    //             color.a=1;
    //         }
    //     }
    // }

    // return color;
    //float pixelSize.x = float(1/ImageSize.x);
    //float pixelSize.y =  float(1/ImageSize.y );

    // ###########################################################################


//     float2 pixelSize = 1/ float2((float) ImageSize.x, (float) ImageSize.y);

// float4 color = tex2D(SpriteTextureSampler, input.TextureCoordinates);
// if(color.a==1) {return color;}
    
// // float2 offsets[8] = {float2(-1,0), float2(1,0), float2(0,1), float2(0,-1), float2(-1,1), float2(1,1), float2(1,-1), float2(-1,-1)};
// float2 offsets[8] = {float2(-pixelSize.x,0), 
//                     float2(pixelSize.x,0), 
//                     float2(0,pixelSize.y), 
//                     float2(0,-pixelSize.y), 
//                     float2(-pixelSize.x,pixelSize.y), 
//                     float2(pixelSize.x,pixelSize.y), 
//                     float2(pixelSize.x,-pixelSize.y), 
//                     float2(-pixelSize.x,-pixelSize.y)};
// int i, j = 0;

// while(i < 10)
// {
//     i++;
//     j=0;
//     while (j < 8)
//     {
//         // float2 curUV = input.TextureCoordinates + ((offsets[j] * pixelSize.x + offsets[j] *pixelSize.y)*  i);
//         float curUVx = input.TextureCoordinates.x + offsets[j].x * (float)i;
//         float curUVy = input.TextureCoordinates.y + offsets[j].y * (float)i;
//         float4 offsetsample = tex2Dlod(SpriteTextureSampler, float4(curUVx, curUVy,0,0));
             
//         if(
//             offsetsample.a==1
            
//             ) 
//         {
//                    return  float4(
//             R,
//             G,
//             B,
//             1);
           
//         }

//         j++;
//     }

    
// }

// return color;

//##############################################################   
int px = (int) input.TextureCoordinates.x*ImageSize.x;
int py = (int) input.TextureCoordinates.y*ImageSize.y;

float2 pixel = input.TextureCoordinates*ImageSize;
float4 color = tex2D(SpriteTextureSampler, input.TextureCoordinates);

if(color.a==1) {return color;}
    
// float2 offsets[8] = {float2(-1,0), float2(1,0), float2(0,1), float2(0,-1), float2(-1,1), float2(1,1), float2(1,-1), float2(-1,-1)};
float2 offsets[8] = {float2(-1,0), 
                    float2(1,0), 
                    float2(0,1), 
                    float2(0,-1), 
                    float2(-1,1), 
                    float2(1,1), 
                    float2(1,-1), 
                    float2(-1,-1)};
int i, j = 0;

// while(i < 10)
// {
//     i++;
//     j=0;
    
    while (j < 8)
    {
        // float2 curUV = input.TextureCoordinates + ((offsets[j] * pixelSize.x + offsets[j] *pixelSize.y)*  i);
        float checkpx=(float)px+(float)BorderSize*offsets[j].x;
        float checkpy=(float)py+(float)BorderSize*offsets[j].y;

        float curUVx = input.TextureCoordinates.x + (float)checkpx/(float)ImageSize.x;
        float curUVy = input.TextureCoordinates.y + (float)checkpy/(float)ImageSize.y;
        float4 offsetsample = tex2Dlod(SpriteTextureSampler, float4(curUVx, curUVy,0,0));
             
        if(
            offsetsample.a==1
            
            ) 
        {
                   return  float4(
            R,
            G,
            B,
            1);
           
        }

        j++;
    }

    
// }

return color;

};

technique SpriteDrawing
{
  pass P0
  {
      PixelShader = compile PS_SHADERMODEL MainPS();
  }
};